// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

part of 'email_verification_cubit.dart';

class EmailVerificationState extends Equatable {
  final bool isVerified;
  final FormStatus status;
  final String? errorMessage;

  const EmailVerificationState({
    this.isVerified = false,
    this.status = FormStatus.pure,
    this.errorMessage,
  });

  EmailVerificationState copyWith({
    bool? isVerified,
    FormStatus? status,
    String? errorMessage,
  }) => EmailVerificationState(
      isVerified: isVerified ?? this.isVerified,
      status: status ?? this.status,
      errorMessage: errorMessage ?? this.errorMessage,
    );

  @override
  List<Object> get props => [isVerified, status];
}
